#Copyright 2012 Nicu Pavel <npavel@mini-box.com>
#Licensed under GPLv2
#import csv
import json
import itertools
from pprint import pprint


#As exported by SuitePG2 Report Items with Known Data
# originally exported with id = Code, name = Denomination
# if key starts with __SKIP it won't get exported to json
# this corresponts to column not actual names that CSV lists on header
unitkeys = [ "id",
         "name",
         "uclass",
         "softatk",
         "hardatk",
         "airatk",
         "navalatk",
         "grounddef",
         "airdef",
         "closedef",
         "target",
         "initiative",
         "gunrange",
         "spotrange",
         "rangedefmod",
         "___SKIPmovemode",
         "movmethod",
         "movpoints",
         "fuel",
         "ammo",
         "cost",
         "__SKIPMonthExpired",
         "__SKIPMonthAvaible",
         "__SKIPYearAvaible",
         "__SKIPYearExpired",
         "__SKIPOrganic Transport",
         "country",
         "__SKIPSpecial1",
         "__SKIPSpecial2",
         "bombercode",
         "icon",
         "__SKIPatkMel",
         "__SKIPmovMel",
         "__SKIPdieMel" ]


# hash for unit properties used by HTML5 PG (not all properties exported ATM see __SKIP entries above)
odict = {}
# list for unit properties used as an alternative to the above hash
olist = [];
# a dictionary with all values from the SuitePG2 exported csv
unitdict = dict.fromkeys(unitkeys)
# final equipment dictionary hash of hash results in a big file > 300k
eqdict = {}
# final equipment dictionary using the hash of list as alternative to the above hash
eqcdict = {}
# Unique set with SHP files that will need to be converted (will be used by convert.py script)
shplist = set()
#from where the html code will load the images of the units
imgpath = "resources/units/images/"
imgext = ".png"
out = ""


f = open('Equip97_REPORT.csv', 'r' )
o = open('equipment.js', 'w'); # file that list each property as a hash, nice but big >300k
oc = open ('equipment-condensed.js', 'w'); # a condensed version that list properties in an array
l = open('equipment-condensed-loader.js','r'); # the javascript that will be appended in equipment-condensed.js to build equipment struct
shp = open('../icons/shp.list', 'w')

#reader = csv.DictReader( f, delimiter=';', fieldnames = keys)

for line in f:
    unitvalues = line.split(';')
    unitdict = dict(itertools.izip(unitkeys, unitvalues))
    olist = []
    # make proper values for our js
    for k,v in unitdict.iteritems():
        if "__SKIP" not in k:
            if k == "name":
                odict[k] = v
                olist.append(v);
            elif k == "icon":
                odict[k] = imgpath + v + imgext
                olist.append(imgpath + v + imgext)
                shplist.add(v.upper() + ".bmp") #SHPTool exports filename as uppercase but extension lowercase
            else:
                odict[k] = int(v)
                olist.append(int(v))
    eqdict[odict["id"]] = odict.copy()
    eqcdict[odict["id"]] = olist

# build the loader for condensed equipment js mapping key order from dictionary to array index
jsloader = "\nvar equipment = {};\n"
jsloader += "for (var i in equipment_condensed)\n"
jsloader += "{\n"
jsloader +="\tvar ud = {};\n"
jsloader +="\tvar e = equipment_condensed[i];\n"

idx = 0
for k in odict:
    jsloader += "\tud." + k + " = e[" + str(idx) + "];\n"
    idx = idx + 1
jsloader += "\tequipment[ud.id] = ud;\n"
jsloader += "}\n"
jsloader += "delete equipment_condensed;\n"

#pprint(eqdict)
#pprint(eqcdict)

o.write("//Automatically generated by tools/equipment/json-export.py\n")
o.write("var equipment = ")
out = json.dumps(eqdict, sort_keys=True, indent=4)
o.write(out)



oc.write("//Automatically generated by tools/equipment/json-export.py\n")
oc.write("equipment_condensed = ")
out = json.dumps(eqcdict, sort_keys=True, separators=(',',':'))
oc.write(out)
oc.write(jsloader)

for i in shplist:
    shp.write("%s\n" % i)
